package com.brilliance.swift.mx2mt.mt110.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

/**
 *
 */
public class Field30Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "30";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        boolean flag30 = false;
        String mtIsseDtStr = "";
        String isseDtStr = getXmlNodeValue(bodyHdrParentElementName, document, "Chq.IsseDt");
        if (StringUtil.isNotEmpty(isseDtStr)) {
            try {
                XMLGregorianCalendar valDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(isseDtStr);
                mtIsseDtStr = DateUtil.format(valDt, "yyMMdd");
                flag30 = true;
            } catch (DatatypeConfigurationException e) {
                throw new SwiftException(e.getMessage());
            }
        }
        if(flag30){
            tags.add(new Tag(name, mtIsseDtStr));
        }
    }
}
