package com.brilliance.swift.mx2mt.mt110.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field32aGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_32A = "32A";

    private static String name_32B = "32B";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String cheVaDt = "";
            String cheAmt = "";
            String cheAmtCcy = "";
            String cheValDtValue = getXmlNodeValue(bodyHdrParentElementName, document, "Chq.ValDt.Dt");
            String amt = getXmlNodeValue(bodyHdrParentElementName, document, "Chq.Amt");
            String ccy = getXmlNodeValue(bodyHdrParentElementName, document, "Chq.Amt@Ccy");
            if ("XAU".equalsIgnoreCase(ccy) || "XAG".equalsIgnoreCase(ccy)
                    || "XPD".equalsIgnoreCase(ccy) || "XPT".equalsIgnoreCase(ccy)) {
                buildSTErrorInfo(63, bodyHdrParentElementName+".Chq.Amt", ccy);
            }
            if (StringUtil.isNotEmpty(amt) && StringUtil.isNotEmpty(ccy)) {
                cheAmt = NumberUtil.formatAmt(new BigDecimal(amt), ccy);
                cheAmtCcy = ccy;
            }
            if (StringUtil.isNotEmpty(cheValDtValue)) {
                XMLGregorianCalendar intrBkSttlmDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(cheValDtValue);
                cheVaDt = DateUtil.format(intrBkSttlmDt, "yyMMdd");
                tags.add(new Tag(name_32A, cheVaDt+cheAmtCcy+cheAmt));
            }else {
                tags.add(new Tag(name_32B, cheAmtCcy+cheAmt));
            }
        } catch (DatatypeConfigurationException e) {
            throw new SwiftException(e.getMessage());
        }

    }
}
