package com.brilliance.swift.mx2mt.mt110.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import java.util.List;

/**
 *
 */
public class Field59Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "59";

    private static String name_59F = "59F";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/59a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int ptsCtry = getXmlNodeCounts(bodyHdrParentElementName, document, "Chq.Pyee.PstlAdr.Ctry");
        int chePyeePstLine = getXmlNodeCounts(bodyHdrParentElementName, document, "Chq.Pyee.PstlAdr.AdrLine");
        String partyPath = bodyHdrParentElementName + ".Chq.Pyee";
        if (ptsCtry > 0){
            String nameAddress = mx_to_mtPartyNameAndAddressLEI1(partyPath);
            tags.add(new Tag(name_59F, nameAddress));
        } else if (chePyeePstLine > 0) {
            boolean structuredAddressIndicator = mx_to_mtAddressLineType(partyPath);
            if (structuredAddressIndicator){
                String nameAddress = mx_to_mtPartyNameAndAddressLEI2(partyPath, "3/");
                tags.add(new Tag(name_59F, nameAddress));
            } else {
                String nameAddress = mx_to_mtPartyNameAndUnstructuredAddress(partyPath);
                tags.add(new Tag(name, nameAddress));
            }
        } else {
            String nameAddress = mx_to_mtPartyNameAndUnstructuredAddress(partyPath);
            tags.add(new Tag(name, nameAddress));
        }
    }
}
