package com.brilliance.swift.mx2mt.mt111.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *
 */
public class Field75Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "75";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String reasonCode = getXmlNodeValue(bodyHdrParentElementName, document, "Chq.ChqCxlOrStopRsn.Rsn.Cd");
        String reasonDescription = "";
        String cancellationReason = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.ChqCxlOrStopRsn.AddtlInf");
        String[][] reasonTable = {
                {"LOST", "ChequeLost"},
                {"DUPL", "DuplicateCheque"},
                {"FRAD", "FraudulentOrigin"},
                {"NARR", "Narrative"},
                {"CUST", "RequestedByCustomer"}
        };
        for (String[] reason : reasonTable) {
            if (reasonCode.equals(reason[0])) {
                reasonDescription = reason[1];
                break;
            }
        }
        String mx75 = "";
            mx75 = "/" + reasonDescription + "/" + cancellationReason;
        List<String> list = StringUtil.outStringList(mx75, 35, "//");
        String mt75 = "";
        if (list != null && list.size() > 0) {
            for (int i=0; i<list.size(); i++) {
                String str = list.get(i);
                if (i < 6) {
                    if (i == 0) {
                        mt75 = str;
                    } else {
                        mt75 += Mx2MtConstants.NEW_LINE + str;
                    }
                }
            }
        }
        if (StringUtil.isNotEmpty(mt75)) {
            tags.add(new Tag(name, mt75));
        }

    }
}
