package com.brilliance.swift.mx2mt.mt112;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtCreator;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.mx2mt.Mx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.mt112.impl.*;
import com.brilliance.swift.util.XmlUtil;
import org.dom4j.Document;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class Mx2Mt112Creator extends AbstractMx2MtCreator {
    @Override
    public void preProcess() throws SwiftException {
        super.preProcess();
        Document document = (Document) context.get(Mx2MtContextIdentifier.MX_XMl_DOCUMENT,true);
        Map<String,String> parentElementMaps = XmlUtil.getParentElementMaps(document);
        context.set(Mx2MtContextIdentifier.APPHDR_PARENT_ELEMENT_NAME,parentElementMaps.get("AppHdr"));
        context.set(Mx2MtContextIdentifier.GRPHDR_PARENT_ELEMENT_NAME,parentElementMaps.get("GrpHdr"));
        context.set(Mx2MtContextIdentifier.BODY_PARENT_ELEMENT_NAME,parentElementMaps.get("Chq"));

    }

    @Override
    public List<Mx2MtTagsGenerate> getGenerateTagList() {
        List<Mx2MtTagsGenerate> fieldsGenerateList = new ArrayList<>();
        fieldsGenerateList.add(new Field20Generate());
        fieldsGenerateList.add(new Field21Generate());
        fieldsGenerateList.add(new Field30Generate());
        fieldsGenerateList.add(new Field32Generate());
        fieldsGenerateList.add(new Field52AGenerate());
        fieldsGenerateList.add(new Field59Generate());
        fieldsGenerateList.add(new Field76Generate());
        return fieldsGenerateList;
    }

    @Override
    protected String getMtType() {
        return Mx2MtConstants.MT_TYPE_112;
    }
}
