package com.brilliance.swift.mx2mt.mt112.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

public class Field21Generate extends AbstractMx2MtTagsGenerate {

    private static String NAME ="21";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int chqCount = getXmlNodeCounts(bodyHdrParentElementName,document,"Chq");
        if ( chqCount>0 ) {
            String chqNb = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.ChqNb");
            if (StringUtil.isNotEmpty(chqNb)) {
                if ( chqNb.length()>16 ) {
                    buildSTErrorInfo(13,"Block4/:21",chqNb);
                    chqNb = chqNb.substring(0,15) + "+";
                }
                tags.add(new Tag(NAME,chqNb));
            }
        }

    }
}
