package com.brilliance.swift.mx2mt.mt112.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.List;

public class Field30Generate extends AbstractMx2MtTagsGenerate {

    public static String name = "30";
    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String issueDtStr = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.IsseDt");

        if ( StringUtil.isNotEmpty(issueDtStr) ) {
            try {
                XMLGregorianCalendar issueDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(issueDtStr);
                String mtIssueDtStr = DateUtil.format(issueDt,"yyMMdd");
                tags.add(new Tag(name,mtIssueDtStr));
            } catch (DatatypeConfigurationException e) {
                throw new RuntimeException(e);
            }
        }else {
            buildSTErrorInfo(114,"Block4/:30",null);
            tags.add(new Tag(name,"991231"));
        }


    }
}
