package com.brilliance.swift.mx2mt.mt112.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.DateUtil;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigDecimal;
import java.util.List;

public class Field32Generate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "32A";

    private static String name_B = "32B";

    @Override
    public void tagGenerate() throws SwiftException {
        try {
            SwiftMessage swiftMessage = context.get(SwiftMessage.class);
            List<Tag> tags = swiftMessage.getBlock4().getTags();
            String bkDtStr = "";
            String bkAmt = "";
            String bkCcy = "";
            String amt = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.Amt");
            String ccy = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.Amt@Ccy");
            if ("XAU".equalsIgnoreCase(ccy) || "XAG".equalsIgnoreCase(ccy)
                    || "XPD".equalsIgnoreCase(ccy) || "XPT".equalsIgnoreCase(ccy)) {
                buildSTErrorInfo(63,bodyHdrParentElementName+".Chq.Amt",ccy);
            }
            if ( StringUtil.isNotEmpty(ccy) && StringUtil.isNotEmpty(amt) ) {
               bkAmt = NumberUtil.formatAmt(new BigDecimal(amt),ccy);
               bkCcy = ccy;
            }
            String bkDtValue = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.FctvDt.Dt");
            if (StringUtil.isNotEmpty(bkDtValue)) {
                XMLGregorianCalendar bkDt = DatatypeFactory.newInstance().newXMLGregorianCalendar(bkDtValue);
                bkDtStr = DateUtil.format(bkDt,"yyMMdd");
                tags.add(new Tag(name_A,bkDtStr+bkCcy+bkAmt));
            }else {
                tags.add(new Tag(name_B,bkCcy+bkAmt));
            }
        } catch (DatatypeConfigurationException e) {
            throw new RuntimeException(e);
        }

    }
}
