package com.brilliance.swift.mx2mt.mt112.impl;

import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

public class Field76Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "76";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        Map<String,String > map =new Hashtable<>();
        map.put("ACCP","Accepted");
        map.put("REJT","Rejected");
        String mxStatusCode = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.ChqCxlOrStopSts.Sts.Cd");
        String mxStatusDes = "";
        String mxAddInfo = getXmlNodeValue(bodyHdrParentElementName,document,"Chq.ChqCxlOrStopSts.AddtlInf");
        for (Map.Entry<String,String > entry :map.entrySet()) {
            if (mxStatusCode.equals(entry.getKey())) {
                mxStatusDes = entry.getValue();
                break;
            }
        }
        String mx76String = "/" + mxStatusDes + "/" + mxAddInfo;
        List<String> list = StringUtil.outStringList(mx76String, 35, "//");
        String mt76 = "";
        if (list != null && list.size() > 0) {
            for (int i=0; i<list.size(); i++) {
                String str = list.get(i);
                if (i < 6) {
                    if (i == 0) {
                        mt76 = str;
                    } else {
                        mt76 += Mx2MtConstants.NEW_LINE + str;
                    }
                }
            }
        }
        if (StringUtil.isNotEmpty(mt76)) {
            tags.add(new Tag(name, mt76));
        }

    }
}
